// Strip or Die!
// by ptdw
//
// v4.5
//
// CREDITS: Inspired by a Flash game of the same name.  Thanks to Banjo for code examples and inspiration.
// Female gungirl and camgirl pictures downloaded from pixabay and were marked as public domain.
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/
// This copyright refers only to this script itself; it does not include any other included resources
// (images, music, sounds, etc.) which remain the property of their owners.
//
// Change Log
// 2.0 Fixes for Android compatibility, added public mode, added urethra electrode
// 3.0 Added sounds when using non-audio estim, misc minor changes
// 3.1 Move SNI extension to top of script.  Need to run script, then close sexscripts, then re-open in order to play
// 3.2 Hopefully finalyy fixed upload bug
// 3.3 Fixed null overloading error
// 3.4 Fixed reporting of exposure
// 3.5 Re-arranged setup, bug fixes and minor enhancements
// 3.6 Made clothing order more logical, minor cleanup
// 3.7 Select new expiration each round
// 3.8 Increase exposure potential for extra rounds, add exposure extension that reduces when played with more bullets
// 3.9 Removed external site support, minor bug fixes
// 4.0 Minor bug fix 
// 4.1 Added optional forfeit
// 4.2 Fixed typo
// 4.3 Better intergation of forfeit, added option to force genital target
// 4.4 Added option for no e-stim
// 4.5 Bug fix for null messages

setInfos(9, "Strip or Die!", "Russian Roulette for an e-stim device (can also be played without). Risk stripping naked for other players to see, or getting a painful shock where it counts!",
    "ptdw", "v4.5", 0x666666, "en", ["pain", "cbt", "estim", "exhibition", "formale", "forfemale", "internet", "android"]);

// This is needed for current versions of SexScripts to talk with the server--likely can be removed in the future
System.setProperty("jsse.enableSNIExtension", "true");
System.setProperty("http.agent", "Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.4; en-US; rv:1.9.2.2) Gecko/20100316 Firefox/3.6.2")

// Debug-sensitive variables
def debug = false
def identifier = loadInteger("intro.launch.firsttime")
def femalePlayer = loadBoolean("intro.female")
def playerName = loadString("intro.name")
def properName = playerName.substring(0, 1).toUpperCase() + playerName.substring(1)
def reset = false
def path = System.getProperty("user.dir")
def watch = false
def desTime = ["30 Seconds","1 minute","5 minutes","15 minutes","30 minutes","1 hour","6 hours","1 day","3 days","1 week"]
def extTime = ["1 minute","5 minutes","15 minutes","30 minutes","1 hour","6 hours","12 hours"]
def extTimes = [0,1,2,3,4,5,6,7,8,9,10,20,30,40,50]

// For debugging only
if (debug) {
    identifier = 20
    playerName = "Debug"
    femalePlayer = false
    reset = false
}

// Set default non-volative variables
if(loadString("stripordie.cloth0")==null || reset)
    if (femalePlayer) save("stripordie.cloth0","panties") else save("stripordie.cloth0","underpants")
if(loadString("stripordie.cloth1")==null || reset)
    if (femalePlayer) save("stripordie.cloth1","bra") else save("stripordie.cloth1","pants")
if(loadString("stripordie.cloth2")==null || reset)
    if (femalePlayer) save("stripordie.cloth2","pants") else save("stripordie.cloth2","undershirt")
if(loadString("stripordie.cloth3")==null || reset)
    if (femalePlayer) save("stripordie.cloth3","shirt") else save("stripordie.cloth3","shirt")
if(loadString("stripordie.cloth4")==null || reset)
    if (femalePlayer) save("stripordie.cloth4","socks") else save("stripordie.cloth4","socks")
if(loadString("stripordie.cloth5")==null || reset)
    if (femalePlayer) save("stripordie.cloth5","shoes") else save("stripordie.cloth5","shoes")
if(loadInteger("stripordie.countdown")==null || reset)
    save("stripordie.countdown",10)
if(loadBoolean("stripordie.blindCountdown")==null || reset)
    save("stripordie.blindCountdown",false)
if(loadBoolean("stripordie.audio_estim")==null || reset)
    save("stripordie.audio_estim",true)
if(loadBoolean("stripordie.no_estim")==null || reset)
    save("stripordie.audio_estim",false)
if(loadString("stripordie.estim_start")==null || reset)
    save("stripordie.estim_start","usbcontrol.exe start") // the command you use to control your device needs to be in the scripts folder
if(loadString("stripordie.estim_finish")==null || reset)
    save("stripordie.estim_finish","usbcontrol.exe stop")
if(loadBoolean("stripordie.reactCam")==null || reset)
    save("stripordie.reactCam",false)
if(loadBoolean("stripordie.beforeCam")==null || reset)
    save("stripordie.beforeCam",true)
if(loadBoolean("stripordie.useWebcam")==null || reset)
    save("stripordie.useWebcam",false)
if(loadBoolean("stripordie.offlineMode")==null || reset)
    save("stripordie.offlineMode",false)
if(loadBoolean("stripordie.public")==null || reset)
    save("stripordie.public",false)
if(loadInteger("stripordie.articles")==null || reset)
    save("stripordie.articles",6)

// Read non-volatile variables
def playerClothing = [null]
playerClothing[0] = loadString("stripordie.cloth0")
playerClothing[1] = loadString("stripordie.cloth1")
playerClothing[2] = loadString("stripordie.cloth2")
playerClothing[3] = loadString("stripordie.cloth3")
playerClothing[4] = loadString("stripordie.cloth4")
playerClothing[5] = loadString("stripordie.cloth5")
def countdown = loadInteger("stripordie.countdown")
def blindCountdown = loadBoolean("stripordie.blindCountdown")
def audio_estim = loadBoolean("stripordie.audio_estim")
def no_estim = loadBoolean("stripordie.no_estim")
def estim_start = loadString("stripordie.estim_start")
def estim_finish = loadString("stripordie.estim_finish")
def reactCam = loadBoolean("stripordie.reactCam")
def beforeCam = loadBoolean("stripordie.beforeCam")
def useWebcam = loadBoolean("stripordie.useWebcam")
def offlineMode = loadBoolean("stripordie.offlineMode")
def publicMode = loadBoolean("stripordie.public")
def playerWearing = loadInteger("stripordie.articles")

// Regular variables
def bullets = 1
def quit = false
def dead = false
def target = "ass cheeks"
def cylinder = [false,false,false,false,false,false,false]
def bodyPartArray = ["thighs","ass cheeks","ass hole","balls","penis shaft","penis head","urethra"]
def pronoun1 = "his"
def pronoun2 = "he"
def pronoun3 = "him"
def strip_level = 0
def choosePart = 0
def strippedNaked = false
def picCount = 0
def maxCountdown = 900
def minSurprise = 30
def maxSurprise = 150
def picsPerState = 1
def prevPlayerSlots = 3
def prevPlayerViews = [0,0,0]
def prevPlayerIDs = [0,0,0]
def prevPlayerTimes = [0,0,0]
def currentPlayerSlot = -1
def prevPlayerSlot = -1
def prevPlayerPronoun1 = "his"
def prevPlayerPronoun2 = "he"
def prevPlayerPronoun3 = "him"
def prevPlayerBefore = null
def prevPlayerAfter = null
def prevPlayerBeforePic = null
def prevPlayerAfterPic = null
def prevPlayerTarget = ""
def prevPlayerFemale = false
def prevPlayerName = ""
def prevPlayerShare = 0
def prevPlayerForfeit = ""
def prevPlayerLink = ""
def prevVictimID = 0
def prevVictimBefore = null
def prevVictimBeforePic = null
def prevVictimTarget = ""
def prevVictimFemale = false
def prevVictimName = ""
def playerBeforePic = null
def playerAfterPic = null
def playerReactPic = null
def imageKeyBefore = null
def imageKeyAfter = null
def playerPastViews = 0
def playerPastShare = 0
def picCountdown = 3
def maxSessionTime = 1830
def cheatWatching = false
def noPlay = false
def beforeSize = 0
def afterSize = 0
def reactSize = 0
def shadowBan = false
def dir = getDataFolder()
def isAndroid = false
if (dir.toLowerCase().contains("android")) isAndroid = true
def expiration = 0
def extensions = 0
def extime = 1
def forfeit = ""
def link = ""

// Configure for a female player
if (femalePlayer) {
    bodyPartArray = ["thighs","ass cheeks","ass hole","labia","vagina","clit"]
    pronoun1 = "her"
    pronoun2 = "she"
	pronoun3 = "her"
}

// Display when a bad URL is given
def badURL = {
	show("That's not a valid URL!\n\nMaybe you forgot the \"http://\"?\n\nLet's try that again...")
	wait(3)
}

// Connect to server
def GetOnlineInfo = {
    def maxViews = 0
    def minViews = 9999
    def maxSlot = 0
    def minSlot = 0

    // Check for connection
    if(!isConnected()) {
        show("Unable to connect to SexScripts, playing in offline mode.")
        showButton("OK")
        offlineMode = true
    } else {
        show("Connecting to server...")
        // Read views & IDs
        for(def i = 0;i < prevPlayerSlots;i++) {

            // Read server variables
            prevPlayerViews[i] = receiveInteger("stripordie.views."+i)
			if (prevPlayerViews[i] == null) prevPlayerViews[i] = 0
            prevPlayerIDs[i] = receiveInteger("stripordie.ids."+i)
            prevPlayerTimes[i] = receiveInteger("stripordie.time."+i)
			if (prevPlayerTimes[i] == null) prevPlayerTimes[i]=0

            // If this player is already on the server or there's a null spot, use that
            if ((prevPlayerIDs[i] == identifier) || (prevPlayerIDs[i] == null)) {
                currentPlayerSlot = i
                if (prevPlayerIDs[i] == identifier) {
                    	playerPastViews = prevPlayerViews[i]
				    playerPastShare = receiveInteger("stripordie.share."+i)
					if (playerPastShare == null) playerPastShare = 0
					if (playerPastShare > 9) playerPastShare = 0
				}
			}
        }

        // Find the entry for the player to replace (if they play with webcam) and who they should see
        for(def i = 0;i < prevPlayerSlots;i++) {

            // Find the entry with the max views
            if (currentPlayerSlot < 0) {
                if ((prevPlayerIDs[i] != null) && (prevPlayerIDs[i] != identifier)
                    && (prevPlayerViews[i] > maxViews)) {

                    maxViews = prevPlayerViews[i]
                    maxSlot = i

                    // Make sure there isn't an older entry with the same views
                    for(def j = 0;j < prevPlayerSlots;j++) {
                        if ((prevPlayerViews[i] == prevPlayerViews[j]) && (prevPlayerTimes[j] < prevPlayerTimes[i])) {

                            maxViews = prevPlayerViews[j]
                            maxSlot = j
                        }
                    }
                }
            }

            // Find the oldest entry with the minimum views
            if ((prevPlayerIDs[i] != null) && (prevPlayerViews[i] != null) && (prevPlayerIDs[i] != identifier) && (prevPlayerViews[i] < minViews)) {
                minViews = prevPlayerViews[i]
                minSlot = i

                // Make sure there isn't an older entry with the same views
                for(def j = 0;j < prevPlayerSlots;j++) {
                    if ((prevPlayerViews[i] == prevPlayerViews[j]) && (prevPlayerTimes[j] < prevPlayerTimes[i] && (prevPlayerIDs[j]!=null))) {

                        minViews = prevPlayerViews[j]
                        minSlot = j
                    }
                }
            }
        }

        // Determine the current player's slot
        if (currentPlayerSlot < 0)
            currentPlayerSlot = maxSlot

        // If there's a valid previous player, read the info
        if (prevPlayerViews[minSlot] != null) {
            prevPlayerSlot = minSlot
            prevPlayerName = receiveString("stripordie.name."+prevPlayerSlot)
            prevPlayerTarget = receiveString("stripordie.target."+prevPlayerSlot)
            prevPlayerBefore = receiveString("stripordie.before."+prevPlayerSlot)
            prevPlayerAfter = receiveString("stripordie.after."+prevPlayerSlot)
            prevPlayerFemale = receiveBoolean("stripordie.female."+prevPlayerSlot)
            prevPlayerShare = receiveInteger("stripordie.share."+prevPlayerSlot)
            prevPlayerForfeit = receiveString("stripordie.forfeit."+prevPlayerSlot)
            prevPlayerLink = receiveString("stripordie.link."+prevPlayerSlot)

			if (prevPlayerShare == null) prevPlayerShare = 0
			if (prevPlayerShare > 9) prevPlayerShare = 0
	
			// Assign pronouns
			if (prevPlayerFemale) {
			    prevPlayerPronoun1 = "her"
    				prevPlayerPronoun2 = "she"
				prevPlayerPronoun3 = "her"
			}

            // If the database record is damaged, delete it for next time
            if ((prevPlayerName == null) || (prevPlayerTarget == null) ||
                (prevPlayerBefore == null) || (prevPlayerAfter == null)) {

                send("stripordie.views."+prevPlayerSlot,null)
                send("stripordie.time."+prevPlayerSlot,null)
                send("stripordie.ids."+prevPlayerSlot,null)
                send("stripordie.name."+prevPlayerSlot,null)
                send("stripordie.target."+prevPlayerSlot,null)
                send("stripordie.before."+prevPlayerSlot,null)
                send("stripordie.after."+prevPlayerSlot,null)
                send("stripordie.female."+prevPlayerSlot,null)
            } else {
                	// Otherwise, download the pictures
				prevPlayerBeforePic = receiveImage(prevPlayerBefore)
				if (prevPlayerBeforePic != null) prevPlayerBeforePic = dir + "images/" + prevPlayerBeforePic
                	prevPlayerAfterPic = receiveImage(prevPlayerAfter)
				if (prevPlayerAfterPic != null) prevPlayerAfterPic = dir + "images/" + prevPlayerAfterPic

				// Fix database if pics are broken
				if ((prevPlayerBeforePic == null) || (prevPlayerAfterPic == null)) send("stripordie.ids."+prevPlayerSlot,null)
            }
        }

        if (debug) {
            show("Connection Successful"
            +"\n\nYour user ID is " + identifier
            +"\n\nYour name is " + playerName
            +"\n\nYour target is " + target
            +"\n\nYour past views:"+playerPastViews
            +"\n\nIDs: "+prevPlayerIDs[0]+", "+prevPlayerIDs[1]+", "+prevPlayerIDs[2]
            +"\n\nViews: "+prevPlayerViews[0]+", "+prevPlayerViews[1]+", "+prevPlayerViews[2]
            +"\n\nTimes: "+prevPlayerTimes[0]+", "+prevPlayerTimes[1]+", "+prevPlayerTimes[2]
            +"\n\nCheat ID: "+receiveInteger("stripordie.cheat.id")
            +"\n\nCheat Name: "+receiveString("stripordie.cheat.name")
            +"\n\nCheat Time: "+receiveString("stripordie.cheat.time")
            +"\n\nCheat Public: "+receiveBoolean("stripordie.cheat.public")
            +"\n\nVictim Name: "+receiveString("stripordie.victim.name")
            +"\n\nCaught Name: "+receiveString("stripordie.cheat.caught.name")
            +"\n\nCaught Pic: "+receiveString("stripordie.cheat.caught.pic")
            +"\n\nCaught Public: "+receiveBoolean("stripordie.cheat.caught.public")
            +"\n\nCurrent Player Slot: "+currentPlayerSlot
            +"\n\nPrevious Player Slot: "+prevPlayerSlot
            +"\n\nPrevious Player Name: "+prevPlayerName
            +"\n\nPrevious Player Female: "+prevPlayerFemale
            +"\n\nPrevious Player Target: "+prevPlayerTarget
            +"\n\nPrevious Player Before: "+prevPlayerBefore
            +"\n\nPrevious Player After: "+prevPlayerAfter)
            showButton("OK")
        }
    }
}

// Randomly select player/pictures for cheat monitoring
def cheatNabber = { cheatPic ->
    if ((!offlineMode) && (useWebcam) && (!shadowBan) && (getRandom(5)==0)) {

        // Is someone else already being monitored for cheating?
        def cheatID = receiveInteger("stripordie.cheat.id")

        // If the cheat monitoring slot is not being used, or if it belongs to the current user, update the info
        if (cheatID == null) {
            send("stripordie.cheat.id",identifier)
            send("stripordie.cheat.name",playerName)
            send("stripordie.cheat.time",getTime())
            send("stripordie.cheat.public",publicMode)
            cheatID = identifier
            cheatWatching = true
        }
        if (cheatID == identifier) {
            def cheatKey = sendImage(cheatPic)
            send("stripordie.cheat.pic",cheatKey)
        }
    }
}

// Player finished without cheating
def noCheat = {
    if ((!offlineMode) && (useWebcam) && (!shadowBan)) {
        def cheatID = receiveInteger("stripordie.cheat.id")

        // If this player is being monitored for cheating, clear them
        if (cheatID == identifier) {
            send("stripordie.cheat.id",null)
            send("stripordie.cheat.pic",null)
            send("stripordie.cheat.public",false)
        }
    }
}

// Request public exposure of player
def exposeNakedPlayer = { cheatID, cheatName, cheatPic ->
	def description = "SexScripts Strip-or-Die Cheater: "
	def localPic = receiveImage(cheatPic)

	// If the image isn't valid, leave
	if (localPic != null) localPic = dir + "images/" + localPic
	else return

	// Display the cheater
	setImage(localPic)

	// Get human verification
	if (getBoolean("<h1>Expose A Cheater!</h1>"
		+cheatName+" risked public exposure, but chickened out and didn't fininsh the game!\n\n"
		+"Is this a valid picture of a real person?","Yes","No")) {

			description += cheatName + " played a game of virtual Russian Roulette, but chickened out before finishing. "

            send("stripordie.cheat.caught.name",cheatName)
            send("stripordie.cheat.caught.pic",cheatPic)
            send("stripordie.cheat.caught.public",true)
	}

	// Clear the cheat slot for the next player
	send("stripordie.cheat.id",null)
    send("stripordie.cheat.pic",null)
    send("stripordie.cheat.public",false)
}


// Catch a cheater
def catchCheat = {
	def cheater = false

    if (!offlineMode) {

        def cheatID = receiveInteger("stripordie.cheat.id")

        // Check for cheating
        if ((cheatID != null) && (cheatID != identifier)) {
            def cheatTime = receiveInteger("stripordie.cheat.time")
            if (cheatTime != null) {
                def timeDiff = getTime() - cheatTime
                if (timeDiff > maxSessionTime) {
					def cheatName = receiveString("stripordie.cheat.name")
					def cheatPic = receiveString("stripordie.cheat.pic")
					def cheatPublic = receiveBoolean("stripordie.cheat.public")
					if (!cheatPublic) {
                    		send("stripordie.cheat.caught.name",cheatName)
                    		send("stripordie.cheat.caught.pic",cheatPic)
                    		send("stripordie.cheat.caught.public",false)
                    		send("stripordie.cheat.id",null)
                    		send("stripordie.cheat.pic",null)
                    		send("stripordie.cheat.public",false)
					} else {
						exposeNakedPlayer(cheatID, cheatName, cheatPic)
					}
                }
            }
        }
    }
}

// Expose a player who cheated, or just say thanks
def goodbye = {
    def cheatImage = null
    def cheatName = null
    def testFile = null
	def temp = ""
	def tempSize = 0

    if (!offlineMode) {

        // Check for a cheater who was caught
        cheatName = receiveString("stripordie.cheat.caught.name")
        if (cheatName != null) {
            def cheatPic = receiveString("stripordie.cheat.caught.pic")
            cheatImage = receiveImage(cheatPic) 
			if (cheatImage != null) cheatImage = dir + "images/" + cheatImage
        }
    }

	// Prepare the dialog
	temp = "<h1>Goodbye</h1>"
	if (watch) {
    		temp += "Now that you've seen what happened to other players, how about playing a game yourself? "
		temp += "...if you have the guts!"
	} else {
    		temp += "Thanks for playing this game to the end and honoring your commitment, "+playerName+". "
        	temp +="\n\nI know it wasn't easy to risk your modesty and your " + target + "!"
	}

    // Check for a cheater's pic
	if (cheatImage != null) testFile = new File(cheatImage)
    if (testFile != null && testFile.exists()) {
		tempSize = testFile.getBytes().size()
	}
    if (tempSize>1500) {
        setImage(cheatImage)
        	temp +="\n\nThis player didn't have the guts to finish playing, and left early. "
        	temp +="So, here's one of the pictures I took of " + cheatName + ", on display for all to see! "
        	temp +="\n\nI know, I'm mean, but a deal is a deal, and at least you understand that concept."
    } else setImage("stripordie/gungirl0.jpg")
    temp += "\n\nSee you (naked) next time! ;)"
	show(temp)

    // Delete previous player's pics
	wait(1)
	if (testFile != null && testFile.exists()) testFile.delete()
}

// Send Player's pictures
def SendPictures = {
    if (!offlineMode) {
        imageKeyBefore = sendImage(playerBeforePic)
        imageKeyAfter = sendImage(playerAfterPic)
    }
}

// Send the obituary
def SendObit = {
    def tempImageKey = null

    if(!offlineMode) {

        // If there's a valid reaction pic, use that instead of the before pic
        if ((playerReactPic != null) && (beforeSize != reactSize)) {
            tempImageKey = sendImage(playerReactPic)
        } else {
            if (imageKeyBefore == null) {
                imageKeyBefore = sendImage(playerBeforePic)
            }
            tempImageKey = imageKeyBefore
        }

        // Write the rest of the data
        if (tempImageKey != null) {
            send("stripordie.victim.id",identifier)
            send("stripordie.victim.female",femalePlayer)
            send("stripordie.victim.name",playerName)
            send("stripordie.victim.target",target)
            send("stripordie.victim.before",tempImageKey)
        }
    }
}

// Read the obituary
def GetObit = {

    // Read the obituary data
    if(!offlineMode) {
        prevVictimBefore = receiveString("stripordie.victim.before")
        if (prevVictimBefore != null) {
            	prevVictimBeforePic = receiveImage(prevVictimBefore)
			if (prevVictimBeforePic != null) { 
				prevVictimBeforePic = dir + "images/" + prevVictimBeforePic
	            	prevVictimID = receiveInteger("stripordie.victim.id")
            		prevVictimFemale = receiveBoolean("stripordie.victim.female")
            		prevVictimName = receiveString("stripordie.victim.name")
            		prevVictimTarget = receiveString("stripordie.victim.target")
        		}
		}
    }
}

// Taunt player with previous victim experience
def ObitTease = { pronoun ->
    def taunt = ["The look of terror on "+pronoun+" face when the pain hit was priceless!",
    "You should have seen "+pronoun+" body writhing in pain!",
    "I *almost* felt sorry for "+pronoun+" poor "+prevVictimTarget+" as I pulled the trigger...almost!",
    "I think I enjoyed seeing "+pronoun+" pain more than I would have enjoyed seeing "+pronoun+" naked body!",
    "I'll admit...it was so much fun to finally hurt "+pronoun+" "+prevVictimTarget+"!"]

    return taunt[getRandom(5)]
}

// Show the obituary
def ShowObit = {
    // Make sure we have a picture
    if (prevVictimBeforePic != null) {
        def testFile = new File(prevVictimBeforePic as String)
        if (testFile.getBytes().size() > 1500) {

            // Show the last victim
            setImage(prevVictimBeforePic)

            // Describe the last victim
            if (prevVictimID == identifier) {
                show("<h1>Previous Victim</h1>Now that my target has been decided, let me remind you about the last time we met, "+prevVictimName+"."
                +"\n\nI mercilessly shocked your " +prevVictimTarget+ " when the gun actually fired! "
                +"\n\n"+ObitTease("your")
                +"\n\nLet your past suffering be a reminder: I'm dead serious about this game, "
                + "and will not hesitate to pull the trigger with my gun pointed at your "+target+"!")
            } else if (prevVictimFemale) {
                show("<h1>Previous Victim</h1>Now that my target has been decided, let's take a moment and pay our respects to poor "+prevVictimName+"."
                +"\n\nI mercilessly shocked her " +prevVictimTarget+ " when the gun actually fired! "
                +"\n\n"+ObitTease("her")
                +"\n\nLet her suffering be an example to you: I'm dead serious about this game, "
                + "and will not hesitate pull the trigger with my gun pointed at your "+target+"!")
            } else {
                show("<h1>Previous Victim</h1>Now that my target has been decided, let's take a moment and pay our respects to poor "+prevVictimName+"."
                +"\n\nI mercilessly shocked his " +prevVictimTarget+ " when the gun actually fired! "
                +"\n\n"+ObitTease("his")
                +"\n\nLet his suffering be an example to you: I'm dead serious about this game, "
                + "and will not hesitate pull the trigger with my gun pointed at *your* "+target+"!")
            }
            showButton("*gulp*")
        }

        // Delete previous victim's pics
        new File(prevVictimBeforePic).delete()
    }
}

// Send Player's info to the server
def SendOnlineInfo = {
	def description = "SexScripts Strip-or-Die Loser: "
	def guid = null
	def success = false

    if(!offlineMode) {

        // Write the rest of the data
        if ((imageKeyBefore != null) && (imageKeyAfter != null)) {
       	    send("stripordie.views."+currentPlayerSlot,0)
        	    send("stripordie.time."+currentPlayerSlot,getTime())
        	    send("stripordie.ids."+currentPlayerSlot,identifier)
        	    send("stripordie.female."+currentPlayerSlot,femalePlayer)
        	    send("stripordie.name."+currentPlayerSlot,playerName)
        	    send("stripordie.target."+currentPlayerSlot,target)
        	    send("stripordie.before."+currentPlayerSlot,imageKeyBefore)
        	    send("stripordie.after."+currentPlayerSlot,imageKeyAfter)
        	    send("stripordie.forfeit."+currentPlayerSlot,forfeit)
        	    send("stripordie.link."+currentPlayerSlot,link)
			
			if (publicMode) {
           		send("stripordie.share."+currentPlayerSlot,expiration)	
				description += properName + " played virtual Russian Roulette with " + pronoun1 + " " + target + " on the line!"
			} else {
           		send("stripordie.share."+currentPlayerSlot,0)	
			}			
		}
    }
	
	return success
}

// Show a previous player
def dispNakedPlayer = {
	def prompt = ""

    // Make sure we have a picture
    if ((prevPlayerBeforePic != null) && (prevPlayerAfterPic != null)) {
        def testFile = new File(prevPlayerBeforePic as String)
        if (testFile != null && testFile.getBytes().size() > 1500) {

            // Expose a previous player
            setImage(prevPlayerBeforePic)

            	// Introduce a player
			if (getBoolean("<h1>Meet "+prevPlayerName+"</h1>"
				+"Before we begin, I'd like to introduce you to a previous player, "+prevPlayerName+"."
                	+"\n\n"+prevPlayerName+" played \"Strip or Die\" with "+prevPlayerPronoun1+" " + prevPlayerTarget + " on the line!"
                	+"\n\n"+prevPlayerPronoun2.substring(0, 1).toUpperCase() + prevPlayerPronoun2.substring(1)+" escaped getting shocked, but did forfeit "
				+prevPlayerPronoun1+" modesty in the process."
                	+"\n\nWould you like to see "+prevPlayerName+" naked?","Yes","No")) {
                		setImage(prevPlayerAfterPic)
					def text = "<h1>"+prevPlayerName+"'s Naked!</h1>"
					text +="While I'm sure "+prevPlayerPronoun2+"'d hate to know a stranger is seeing "
					text +=prevPlayerPronoun3+" naked, "
                 	text +="being shocked on the "+prevPlayerTarget+" would probably have been worse!"
					show(text)
					showButton("LOL")

					// Show previous player forfeit
					if ((prevPlayerForfeit != null) && (prevPlayerForfeit != "")) {
						text = "<h1>Forfeit</h1>Before you go, there's one more thing! To make the game more exciting, "+prevPlayerName
						text += " agreed to a forfeit upon being stripped and exposed.  It may be a task, link, confession, or personal info. Here are the details:\n\n"
						text += prevPlayerForfeit
						if ((prevPlayerLink == null) || (prevPlayerLink == "")) {
							show(text)
							showButton("OK")
						} else {
							while (getSelectedValue(text, ["Open Link","Done"])==0) {
								if (getBoolean("Please be cautious when opening unknown sites or files."
									+"\n\nDo you want to open " + prevPlayerLink + " in an external browser?","Yes","No")) {
									useUrl(prevPlayerLink)
								}
							}
						}
					}

					if (!watch) {
    						setImage("stripordie/gungirl4.jpg")
						show("<h1>Your Turn!</h1>"
                 		+"Don't laugh, you're up next! Let's decide your fate... You may be the next player to lose "+pronoun1+" modesty!")
                 		showButton("*gulp*")
					}
            }

            // Increment the view count
            if (!offlineMode) send("stripordie.views."+prevPlayerSlot,prevPlayerViews[prevPlayerSlot]+1)

		    // Delete previous player's pics
    			new File(prevPlayerBeforePic).delete()
    			new File(prevPlayerAfterPic).delete()
        }
    }
}

// Display the player's state of undress
def dispPlayer = {
    if (useWebcam) {
        setImage(playerAfterPic)
    } else {
        if(getRandom(picsPerState)==0)
            strip_level = (6-playerWearing)+"a"
        else
            strip_level = (6-playerWearing)+"b"

        // Chose correct pic set for player's sex
        if (femalePlayer) setImage("stripordie/fstrip"+strip_level+".jpg")
        else setImage("stripordie/strip"+strip_level+".jpg")
    }
}

// Photograph the players reaction while being shocked
def takeReaction = {
    def snapfile = null

    snapfile = getImage("Starting webcam..")
    playerReactPic = snapfile
    new File(dir + "images/stripordie/player_react.jpg").delete()
    def File tempfile = new File(dir + "images/stripordie/player_react.jpg") << new File(snapfile).getBytes()
    reactSize = tempfile.length()
}

// Take a picture of the player
def takePic = {
    def picok = false
    def snapfile = null

    // Take a picture and get player confirmation
    while (!picok) {
        // Show a countdown
        for(def k = picCountdown;k > 0;k--) {
            show("..."+k+"...")
            wait(1)
        }
        show("*snap*")

        snapfile = getImage("Starting webcam..")
        show(null)
        setImage(snapfile)
        show(null)
        picok = getBoolean("Is that picture OK?", "Yes", "No")
    }
    picCount += 1

	// Non webcam pic?
	if (isAndroid && (!snapfile.toLowerCase().contains("pictures") && !snapfile.toLowerCase().contains("dcim"))) shadowBan = true
	if (!isAndroid && !snapfile.contains("captured")) shadowBan = true

    // Save the first picture
    if (picCount == 1) {
        playerBeforePic = snapfile
        new File(dir + "images/stripordie/player_start.jpg").delete()
        def File tempfile = new File(dir + "images/stripordie/player_start.jpg") << new File(snapfile).getBytes()
        beforeSize = tempfile.length()
    }

    // Save the player's most naked picture
    playerAfterPic = snapfile
    new File(dir + "images/stripordie/player_current.jpg").delete()
    def File tempfile = new File(dir + "images/stripordie/player_current.jpg") << new File(snapfile).getBytes()
    afterSize = tempfile.length()

    // Validate
    if (picCount > 1) {
        if ((beforeSize == afterSize) || (beforeSize < 15000) || (afterSize < 15000)) {
            shadowBan = true
            if (!offlineMode && cheatWatching) send("stripordie.cheat.id",null)
        }

        // Randomly select a player/pic for cheat monitoring
        cheatNabber(snapfile)
    }
}

// Player removes an article of clothing
def stripPlayer = {
	def result = false

	// Display the last pic
    show(null)
    dispPlayer()

	// Tell player to take it off
    if(playerWearing>0) {
        playerWearing -= 1
        if (playerWearing==0) strippedNaked = true


        def tauntStrip = ["Getting cold yet?",
        "Woohoo, you have to strip!",
        "Uh oh! You know what that means!",
        "Let's see some more skin!"]

        show(tauntStrip[getRandom(4)]+"\n\nTake off your "+playerClothing[playerWearing]+".")
        showButton("OK")
        if (useWebcam) takePic()
    } else {
        // Player lost modesty and is exposed in webcam mode
        def tauntNaked = ["Awww, how cute you look! I wonder who else will see this!",
        "Are you nervous? What if someone you know sees this!",
        "You are exposed for the world to see! *giggle*",
        "You're naked...NAKED! Who's watching? Better than being shocked, huh?",
        "Nice body! I'm sure everyone will enjoy seeing it!"]
		if (!audio_estim) playBackgroundSound("spinthebottle/laughing.mp3")
        if (useWebcam && !offlineMode) {
            	show("<h1>Stripped & Exposed!</h1>"+tauntNaked[getRandom(5)]+"\n\nYour pictures will be shown to other players for "
            	+"a limited time. \n\nSorry, but that was our deal!")
        		if (!shadowBan) result = SendOnlineInfo()
        		showButton("*blush*")		
        } else {
			show("<h1>Stripped & Exposed!</h1>"+tauntNaked[getRandom(5)])
        		showButton("*blush*")
        }
    }
}

//Rules explaination
def rulesDisplay = {
    show("The object of this game is destroy your sense of modesty by making you beg to be stripped naked.")
    showButton("How is that possible?")
    show("Glad you asked! Ever heard of Russian Roulette?"
    +"\n\nYou load one or more bullets into a revolver and give the cylinder a spin. "
    +"If you're lucky, there's no bullet in the chamber when you pull the trigger. "
    +"\n\nIn our little game, if there's no bullet, you take off an article of clothing!")
    showButton("What happens when I run out of clothes?")
    show("If you run out of clothes, we all get to see you naked, of course *giggle*!"
    +"\n\nAfter you take off your last article of clothing, you pull the trigger one more time. "
    +"If the gun doesn't fire, you're exposed. If it fires, at least nobody will see you naked..."
    +"\n\nThis game can be played in two modes: with and without the webcam."
    +"\n\nIf you play in webcam mode and are exposed, your pictures will automatically be show to other players!"
    +"\n\nWithout the webcam, it'll be up to you to ensure your exposure risk is high enough to make the game interesting.")
    showButton("And what if the gun fires?")
    show("I'm so sorry Dear, but if the gun fires, you're going to be in excruciating pain."
    +"\n\nYou see, a very sensitive part of your body will be connected to an e-stim unit, set at maximum power. "
    +"\n\nIt's up to you what body part you sacrifice...or I can help you decide.  Just keep it below the waist!")
    showButton("So if the gun fires, I have to shock myself?")
    show("Nope! I'll take care of that for you. All you have to do is fire the gun and see what happens! "
    +"\n\nWhen the gun fires, I'll play an e-stim trigger audio file that feeds into your e-stim device."
    +"\n\nYou won't have time to react...you'll be in excruciating pain until I stop the torture.")
    showButton("*shudder*")
    show("So, as I said when we started, given the choice of taking off your clothes or being mercilessly shocked, "
    +"I'm guessing you'll turn into a regular exhibitionist!"
    +"\n\nYou can only quit the game after playing one round naked, or being shot!"
    +"\n\nYou'll either strip naked...or die.")
    showButton("What if I don't have an e-stim device?")
    show("You can still play without an e-stim device! "
    +"\n\nYou must decide in advance what pain you'll endure if the gun fires."
    +"\n\nThen, if the gun fires, you'll have to immediately inflict yourself with that pain."
    +"\n\nE-stim devices can automatically inflict the pain, which makes the game much more nerve-wracking!")
    showButton("I understand")
    show("Before we begin, a few tips: "
    +"\n\n1) You can play naked without the stripping component by starting with zero articles of clothing."
    +"\n\n2) If you start clothed, you should be wearing "
    + playerClothing[5] + ", " + playerClothing[4] + ", " + playerClothing[3] + ", " + playerClothing[2] + ", "
    + playerClothing[1] + ", and " + playerClothing[0] + "."
    +"\n\n3) You can start with fewer articles, but they will be removed in the order above."
    +"\n\n4) This game should not be played in private with no risk of exposure. If you don't play with the webcam, you should "
    +"play with a partner, or broadcast your fate via a video streaming site. Stripping should be high-risk!"
    +"\n\n5) If you're afraid you may rip the electrodes off your body when the torture begins, bind you hands quickly after "
    +"firing the gun. That way, you have no time to react! The torture is VERY intense, but doesn't last too long.")
    showButton("Ok, I got it.")
    show("*** SAFETY NOTICE ***\n\nA word about safety: this game is designed to be a stressful mind-fuck. Thus, the consequences are extreme."
    +"\n\nHowever, you must use common sense. Only play with e-stim settings that you know are safe. NEVER connect "
    +"electrodes above the waist where electricity could flow across the heart."
    +"\n\nThe goal is to have an extremely painful--yet safe--consequence if the gun fires.\n\nThis way, you can experience what "
    +"it really feels like to play Russian Roulette!")
    showButton("I agree")
    show("One more thing:  When I said this is high-stakes, I wasn't joking. "
    +"\n\nIn a worst-case scenario, you'll need to connect electrodes to your "+
    bodyPartArray[bodyPartArray.size()-1] +" and turn the power to maximum. "
    +"\n\nOnce the electrodes are connected, you can put your clothes back on with only the wires coming out of your pants. "
    +"\n\nThis game is not for the faint of heart!")
    showButton("I understand")
}

// Load the gun
def loadGun = {
    def unloaded = bullets
    cylinder = [false,false,false,false,false,false,false]

    while (unloaded > 0) {
        def cylNum = getRandom(6)
        if (!cylinder[cylNum]) {
            cylinder[cylNum] = true
            unloaded -= 1
        }
    }
}

// Show the cylinder contents (for debugging)
def showCylinder = {
    def cylVisual = ""
    for (i in 0..5) {
        if (cylinder[i]) cylVisual = cylVisual + "X"
        else cylVisual = cylVisual + "O"
    }
    show(cylVisual)
    showButton("OK")
}

// Advance the cylinder
def advance = {
    cylinder[6] = cylinder[0]
    for (i in 0..5) cylinder[i] = cylinder[i+1]
}

// Spin the cylinder
def spin = {
    def revs = getRandom(24)
	setImage("stripordie/cylinder.jpg")
    show("Spinning the cylinder...")
	if (!audio_estim) playBackgroundSound("stripordie/spin.mp3")
    for (j in 0..revs) advance()
    wait((revs/4)+1)
	show("")
}

// Pull the trigger
def fire = {
    if (cylinder[0]==true) {
		if (audio_estim) {
        		playBackgroundSound("stripordie/stimshot.wav")
		  	wait(1)
	      	show("***BANG***")
          	setImage("stripordie/bloodspatter.png")
          	if (reactCam) takeReaction()
          	wait(5)
        } else {
			playBackgroundSound("stripordie/fire.mp3")
          	if (!no_estim) {
				useFile(path+"/"+estim_start)
          		wait(1)
			}
			if (no_estim) {
		  		show("***BANG***\n\nINFLICT PAIN NOW!")
			} else {
		  		show("***BANG***")
			}
          	setImage("stripordie/bloodspatter.png")
          	if (reactCam) takeReaction()
          	wait(2)
          	if (!no_estim) useFile(path+"/"+estim_finish)
        }
        wait(5)
        dead = true
    } else {
		if (!audio_estim) playBackgroundSound("stripordie/click.mp3")
		wait(1)
        show("*click*")
        advance()
        wait(3)
        show(null)
        stripPlayer()
    }
}

// Choose a body part to target
def chooseTarget = { minTarget ->
	choosePart = -1 
	while (choosePart < 0 || choosePart < minTarget) {
		choosePart = getRandom(bodyPartArray.size())
	}
    target = bodyPartArray[choosePart]
}

def Setup = {
    def stimOk = false

    // How much time?
    setImage("stripordie/timer.jpg")
    def delayMenu = getSelectedValue("After the gun is loaded and ready to fire, I can give you a countdown before pulling the trigger. "
    +"If you're afraid you may chicken out, you can add enough time to place yourself in restraints first."
    +"\n\nIf you'd prefer, I can decide when to pull the trigger and surprise you. I'll give you at least 30 seconds to prepare, "
    +"but I may wait up to three minutes before actually pulling the trigger.  It's so much fun to see you sweat!"
    +"\n\nLastly, I can pull the trigger as soon as the gun is ready, with no delay whatsoever."
    +"\n\nWhen the gun is ready to fire, how long to you want me to wait?",["Countdown","Surprise Me","No Delay"])

    // Countdown
    blindCountdown = false
    if (delayMenu == 0) {
        countdown = getInteger("How many seconds should I wait before pulling the trigger?", countdown)

        if (countdown > maxCountdown) countdown = maxCountdown
        if (countdown < 1) countdown = 0
    }
    // Surprise
    else if (delayMenu == 1) {
        blindCountdown = true
    }
    // No Delay
    else {
        countdown = 0
    }
    save("stripordie.countdown",countdown)
    save("stripordie.blindCountdown",blindCountdown)

    // Customize clothing
    useWebcam = false
    dispPlayer()
	def valid = false
	while (!valid) {
		playerWearing = getInteger("How many articles of clothing will you be wearing for the game? (0-6):", playerWearing)
		if ((playerWearing >= 0) && (playerWearing <= 6)) valid = true
	}
    dispPlayer()
    save("stripordie.articles",playerWearing)
    if(getBoolean("Would you like to verify or change the names of the articles that you'll be wearing?","Yes","No")) {
        for (def l=playerWearing;l>0;l--) {
            playerClothing[l-1] = getString("Tell me what you are wearing for article number "+l+". "
            +"\n\nArticles will be removed in order, from highest to lowest.", playerClothing[l-1])
            switch(l) {
            case 1:
                save("stripordie.cloth0",playerClothing[l-1])
                break
            case 2:
                save("stripordie.cloth1",playerClothing[l-1])
                break
            case 3:
                save("stripordie.cloth2",playerClothing[l-1])
                break
            case 4:
                save("stripordie.cloth3",playerClothing[l-1])
                break
            case 5:
                save("stripordie.cloth4",playerClothing[l-1])
                break
            case 6:
                save("stripordie.cloth5",playerClothing[l-1])
                break
            }
        }
    }

    // Customize punishment
    no_estim = false
	audio_estim = false
    setImage("stripordie/cry.png")
    def menu = getSelectedValue("For the most realistic experience, I need a method of automatically inflicting "
    +"you with severe pain, should the gun fire and you get \"shot\"."
    +"\n\nBy default, the game uses an audio-based e-stim device, which is connected to your computer's headphone port. "
    +"\n\nHowever, you can also choose to use any sort of external device, which is controlled by a start and stop command "
    +"run by your computer when the gun fires."
    +"\n\nHow will pain be inflicted?", ["External Device","Audio E-stim","Other"])

    // Audio e-stim
    setImage("stripordie/abox.png")
    if(menu==1) {
        audio_estim = true
        while (!stimOk) {
            if (getBoolean("If you want to get a small taste of what it will feel like when you get shot, press the \"TEST\" button "
                +"to feel a short sample at half the intensity."
                +"\n\nIf you think this is painful, just wait until you get shot!","TEST","Continue")) {

                playBackgroundSound("stripordie/stimcal.wav")
                wait(1)

            } else stimOk = true
        }
    }

    // External device
    else if(menu==0) {
        audio_estim = false

        // Test and setup the external device
        def extOk = false
        while (!extOk) {

            // Define the external commands used to control the device
            setImage("stripordie/2b.png")
            estim_start = getString("Let's make sure your computer is linked to your device with the correct commands."
            +"\n\nWhat is the command your computer runs to start your device:",estim_start)
            estim_finish = getString("What is the command your computer runs to stop your device:",estim_finish)

            // Test
            stimOk = false
            while (!stimOk) {
                if (getBoolean("It is best to have a quick test first! Turn the output down to half and press the \"TEST\" button "
                    +"to feel a short sample - remember to put the output back up to full after."
                    +"\n\nIf you think this is painful, just wait until you get shot!","TEST","Continue")) {

                    useFile(path+"/"+estim_start)
                    wait(1)
                    useFile(path+"/"+estim_finish)
                    wait(1)

                    if (getBoolean("Did the device work correctly?","Yes","No")) {
                        stimOk = true
                        extOk = true
                    } else stimOk = true
                } else {
                    stimOk = true
                    extOk = true
                }
            }
        }
    } else if(menu == 2) no_estim = true

    save("stripordie.audio_estim",audio_estim)
    save("stripordie.estim_start",estim_start)
    save("stripordie.estim_finish",estim_finish)

   // Offline Mode?
    offlineMode = false
    setImage("stripordie/ethernet.jpg")
    if(getBoolean("Do you want to play in offline mode?'"
    +"\n\nIn offline mode, the game will still function normally, but will not connect to the server. "
    +"You won't see other players, and they won't see you."
    +"\n\nSince there's no risk of real exposure, it's not nearly as exciting! However, you can get a feel for the game "
    +"before you play for real. \n\nDisconnect from the internet?","Yes","No")) {
        offlineMode = true
    }
    save("stripordie.offlineMode",offlineMode)

	// Online Options
	if (!offlineMode) {
  		// Webcam?
    		setImage("stripordie/camgirl.jpg")
    		if(getBoolean("Do you want to play for real with the webcam enabled?"
    			+"\n\nWARNING: If you choose to use the webcam and escape being shocked while naked, "
    			+"other players will be \"introduced\" to you.\n\nFirst they'll see you clothed, and then they'll "
    			+"have the option to see you naked! They'll also see your name, as well as which body part was targeted."
    			+"\n\nAny of the pictures I take have a chance of being shared, so proceed with caution!"
    			+"\n\nYou can still play the full game without using a webcam, so please don't waste server "
    			+"resources by uploading blank or fake pictures.  Thank you!  "
    			+"\n\nAre you willing to take the risk?","Yes","No")) {
        		useWebcam = true
   		} else {
        		useWebcam = false
    		}

  	  	// Reaction Cam?
    		reactCam = false
		beforeCam = false
   		if (useWebcam == true) {
        		def example = getSelectedValue("Can I use you as an example for other players?"
        		+"\n\nIf you get shocked, I may choose to use you as an example for other players, and show them your clothed picture as well as what body part I shocked. "
			+"Your naked picture will *not* be shared unless you escape being shocked."
        		+"\n\nInstead of using your clothed picture, I can take a picture of you as you're being shocked."
        		+"\n\nWARNING: If you let me take a picture of your reaction, you will "
        		+"*not* have the opportunity to review or approve that picture, so proceed with caution!"
        		+"\n\nWhat can I show other players if you get shocked?",["Don't show anything","Show my before pic","Show my reaction"])

			switch(example) {
        			case 1:
        				beforeCam = true
                		break
            		case 2:
        				reactCam = true
                		break
			}
    		}

    		// Public Exposure Mode?
    		//publicMode = false
    		//if (useWebcam == true) {
        	//	publicMode = getBoolean("Do you want to risk public exposure?"
        	//		+"\n\nIf you are forced to strip naked, your nude picture will be posted to a "
		//		+"website, where everyone will get to see you naked! "
        	//		+"\n\n<b>WARNING: Once your picture is uploaded, there's no way to delete it! You will be exposed for a random length of time, up to several days!</b>"
        	//		+"\n\nDo you give up all rights to your pictures and consent to their publication online?","Yes","No!")
		//}

	} else {
        	useWebcam = false
        	beforeCam = false
        	reactCam = false
    		publicMode = false
	}

    	save("stripordie.useWebcam",useWebcam)
    	save("stripordie.reactCam",reactCam)
    	save("stripordie.beforeCam",beforeCam)
    	save("stripordie.public",publicMode)
}

def Rules = {
    rulesDisplay()
    while(getBoolean("Do you need to go back over the rules again?","Yes","I understand them"))
    {
        rulesDisplay()
    }
}

// Intro
def text = ""
def initial_setup = true

while(initial_setup)
{
	def menuOpts = ["Review Rules","Setup","Play"]
	if (!offlineMode) menuOpts = ["Review Rules","Setup","Play","Watch"]

    setImage("stripordie/gungirl0.jpg")
    def menu = getSelectedValue("<h1><font color=yellow>Strip Or Die!</font></h1>"
	+"Hi, "+playerName+"! Do you have the guts to play Russian Roulette with me? Which do you fear more? Pain or humiliation? Hehe..."
    +"\n\nThis is a high-stakes game where you'll either end up naked or \"dead\". There's really no winner or loser. Either you'll "
	+"be stripped naked for the world to see, or you'll be painfully shocked!"
    +"\n\nBe sure you fully understand the rules before you play...you have a lot to lose!"
    +"\n\nWhat do you want to do?", menuOpts)
    if(menu==1) Setup()
    else if(menu==0) Rules()
    else initial_setup = false

	if (menu==3) watch = true
}

// Connect to the server and read basic info
if (!offlineMode) GetOnlineInfo()

// Check offline mode again, in case we couldn't connect
if (!offlineMode) {

    // Show a previous player, if one exists
    dispNakedPlayer()

    // Tease player if they've been exposed
    if (playerPastViews > 0) {
        setImage("stripordie/camgirl.jpg")
		text = "<h1>Exposed!</h1>"
        if (playerPastViews == 1) {
            text += "By the way, I'm not sure how to break this to you, but someone has already seen you naked!"
        } else {
            text += "By the way, I'm not sure how to break this to you, but "+ playerPastViews +" players have already seen you naked!"
        }

		show(text)
		showButton("*blush*")
    }
}

// Voyeur mode
if (watch) {
	GetObit()
    	ShowObit()
	goodbye()
	return
}

// Set player start clothing
show(null)
if (useWebcam) {
    setImage("stripordie/camgirl.jpg")
    show("<h1>Clothed Picture</h1>Lets take your picture before we start!"
    +"\n\nThis is your \"before\" picture, and is what other players will see first if they're introduced to you."
    +"This picture should show your current state of dress without any nudity."
    +"\n\nWhile not mandatory, I suggest you show your face in this picture. Showing your face will "
    +"increase the stakes, and make the game much more...thrilling!"
    +"\n\nThis picture will ONLY be shown to other players if you end up surviving a round that you played while naked."
    +"\n\nSmile for the camera!")
    showButton("OK")
    takePic()
} else {
    if (femalePlayer) setImage("stripordie/fstrip0a.jpg")
    else setImage("stripordie/strip0a.jpg")
}

// Figure out what the player is wearing
show(null)
dispPlayer()

// Taunt based on what player is wearing
def wearingTaunt = "Looking good!"
if (playerWearing > 3) {
    wearingTaunt = ["You're sure wearing a lot today!\n\nYou'll be really lucky if you survive without being shot.",
    "This should be fun to watch!\n\nWith that much to take off you're going to spend a lot of time in front of the gun!",
    "Fully dressed I see!\n\nThis should be a particularly stressful game...for you!"]
} else if (playerWearing > 0) {
    wearingTaunt = ["Not wearing much, are you?\n\nMy guess is you'll soon be naked and exposed!",
    "Only wearing "+playerWearing+" huh?\n\nIt won't be long before everyone sees what you've got under those clothes!",
    "Already showing a bit of skin I see!\n\nTake a deep breath, it will all be over soon!"]
} else {
    wearingTaunt = ["Starting out naked?\n\nThis will be a quick game! Prepare for the worst!",
    "Sexy!\n\nI can't wait to show everyone else that cute little body of yours...",
    "Haha! You kind of look pathetic like that.\n\nI can't believe you're willing to risk everyone seeing you this way!"]
}
show(wearingTaunt[getRandom(3)])
wait(5)

// Get forfeit
if (!offlineMode) {
	forfeit = getString("<h1>Forfeit</h1>To make the game more exciting, you can enter additional information here that will be shown to viewers if you end up naked and exposed."
	+"\n\nFor example, you can provide a few more personal details to make the exposure more humiliating, or promise to do a forfeit like stripping naked on cam for the first three people "
	+"to contact you, or link to an unsee.cc image that's even more humiliating."
	+"\n\nA forfeit is entirely optional, but for a more exciting game, enter something that will raise the stakes even higher!"
	+"\n\nEnter a description of your forfeit, but not the URL (or leave blank):", "")   

	// Get the URL
	if (forfeit != "") {
		def valid = false
		while (!valid) {
			link = getString("What is the URL (or blank):", "")

			// Verify that the URL is valid
			if (link != "") {
				try {
    					def URL url = new URL(link)
    					def URLConnection conn = url.openConnection()
    					conn.connect()
					valid = true
				} catch (MalformedURLException e) {
					badURL()
					valid = false
				} catch (IOException e) {
					bad(URL)
					valid = false
				}
			} else valid = true
		}
	}
}

// Get another picture if the player is already naked
if ((playerWearing == 0) && (useWebcam)) {
	dispPlayer()
	show("Picture time again! \n\nSince you're already naked, I need a second even *more* embarrassing and explicit picture...just in case you survive."
	+"\n\nUp the ante, "+playerName+"!")
	showButton("Ready")
	takePic()
    if ((!offlineMode) && (!shadowBan)) SendPictures()
	show(null)
}

// Point the gun
setImage("stripordie/gungirl2.jpg")
def aim = getSelectedValue("<h1>Aim</h1>Now you need to decide which body part to sacrifice if the gun fires."
    +"\n\nDo you want me to decide where to point the gun?",["Yes (sensitive body parts)","Yes (any body part)","No (I will choose)"])
if (aim < 2)
{
	if (aim == 0) chooseTarget(2)
	else chooseTarget(0)
    setImage("stripordie/gungirl4.jpg")
    show("Hummmm....where should I aim?")
    wait(getRandom(8)+3)
}
else {
    target = getString("Ok, where will you attach the electrodes:", target)
}
show("Alright then, it's decided. \n\nI'll be aiming for your "+target+"!")
if (choosePart>=3)
    showButton("*gulp*")
else
    showButton("OK")

// Show previous victim
if (!offlineMode) {
    GetObit()
    ShowObit()
}

// Attach electrodes
show(null)
def electImg = dir + "images/stripordie/"+target+".jpg"
def testImg = new File(electImg)
if (testImg.exists()) electImg = "stripordie/"+target+".jpg"
else electImg = "stripordie/thighs.jpg"
setImage(electImg)

// Correct wording
def attachHow = "Attach the e-stim electrodes to your "+target+"."
if ((target == "ass hole") || (target == "vagina") || (target == "urethra")) attachHow = "Insert the e-stim probe into your "+target+"."
else if ((target == "penis head") || (target == "balls")) attachHow = "Attach the electrode to your "+target+"."

// Display instructions
if (no_estim) {
	show("<h1>Get Ready!</h1>We're almost ready to play! But first, we need to get ready for the pain."
	+"\n\nI know it won't be easy, but if the gun fires, you must be ready to immediately inflict pain to your "+target+"! OUCH! "
	+"\n\nIf you have a tool or device you'll be using to inflict the pain, get that ready now.")
	showButton("Ready!")
} else {
	show("<h1>Wire Up!</h1>We're almost ready to play! But first, we need to get you wired up."
	+"\n\nI know it won't be easy to attach the electrodes. After all, imagine how painful it will be if "
	+"you're unlucky enough to pull the trigger on a loaded cylinder! OUCH!"
	+"\n\nLet's just get this over with. " + attachHow)
	showButton("Wired up!")

	// Liz - added change to allow different types of e-stim (not going to ask as not audio people will be
	//       happy to edit def above)
	def stimOk = false	
	if (audio_estim) {		
 		// Connect audio
  		setImage("stripordie/abox.png")
  		show("<h1>Wire Up!</h1>Now it's time to give me control of your e-stim device. "
  		+"\n\nMake sure all other audio sources on your computer are muted. "
  		+"\n\nThen, turn up your computer's volume to 100% and connect the headphone port to your e-stim device.")
  		showButton("Audio ready!")

  		// Power up
  		while (!stimOk) {
 	   		if (getBoolean("<h1>Power Up!</h1>Now for the final step. I know this is going to be difficult to do... "
    				+"\n\nDon't think about it.  Just do what I say.  The gun probably won't fire anyway...hehe"
    				+"\n\nSet your e-stim to trigger on audio input, and turn up the output!"
    				+"\n\nIf you want to get a small taste of what it will feel like when you get shot, press the \"TEST\" button "
    				+"to feel a short sample at half the intensity."
    				+"\n\nIf you think this is painful, just wait until you get shot!","TEST","Powered Up!")) {
    		    		playBackgroundSound("stripordie/stimcal.wav")
    		    		wait(1)
    			} else stimOk = true
  		}
	} else {
	    // Connect estim
    		setImage("stripordie/2b.png")
    		show("Now it's time to give me control of your external device. "
    		+"\n\nYour computer is linked to your external device with the commands defined in setup. "
    		+"\n\nVerify that your device is powered on and set to the correct mode.")
    		showButton("Device ready!")

    		while (!stimOk) {
        		if (getBoolean("Now for the final step. I know this is going to be difficult to do... "
        		+"\n\nDon't think about it.  Just do what I say.  The gun probably won't fire anyway...hehe"
        		+"\n\nTurn up your power output as high as it goes!"
        		+"\n\nIf you want to test the level first, turn the output down to half and press the \"TEST\" button "
        		+"to feel a short sample - remember to put the output back up to full afterwards!"
        		+"\n\nIf you think this is painful, just wait until you get shot!","TEST","Powered Up!")) {
            		useFile(path+"/"+estim_start)
            		wait(1)
            		useFile(path+"/"+estim_finish)
            		wait(1)
        		} else stimOk = true
    		}
	}
}

// How many bullets?
setImage("stripordie/loadgun.jpg")
bullets = getInteger("<h1>Load</h1>Let's load the gun. I'll place each bullet in a random chamber."
+"\n\nThe more bullets you add, the greater your chance of being shot, and the lower your chance of being exposed."
+"\n\nEach bullet also reduces the potential length and severity of your exposure...if you survive."
+"\n\nEnter the number of bullets you wish to load, or 0 if you want me to decide (0 to 6).", bullets)
if (!audio_estim) playBackgroundSound("stripordie/load.mp3")
if (bullets > 6) bullets = 6
if (bullets < 0) bullets = 1
if (bullets == 0 ) bullets = getRandom(6)+1

// Remind the player of settings and commitments
def extraText = "I'll be pulling the trigger after a "+countdown+" second countdown."
if (blindCountdown) {
    extraText = "Once you're ready, I'll decide when to actually pull the trigger. You'll have at least 30 seconds to prepare, but I may decide to make you sweat a little longer."
} else if (countdown == 0) {
    extraText = "I'll pull the trigger immediately, with no countdown."
}
if (reactCam) {
    extraText = extraText + "\n\nPoint the camera at your face now, so that I can take a picture of your reaction if you get shot!"
}

// Exposure warning
setImage("stripordie/gungirl2.jpg")
def tauntPointed = ["OMG, I'm so excited! Either way this will be fun to watch!",
"Are you nervous yet? Ummm...you probably should be!",
"I'm kind of rooting for seeing your "+target+" destroyed!",
"While I'd like to see more skin, destroying your flesh would be even more rewarding!",
"This is going to be so much fun!",
"To be honest, I'm hoping to see you naked..."]

if (publicMode) extraText += "\n\n<b>WARNING:</b> You are playing in PUBLIC mode! If you are stripped, you will be exposed and humiliated publicly!"

show("<h1>Ready!</h1>"+tauntPointed[getRandom(5)]
+"\n\nYou have "+bullets+" in the chamber, with the gun pointed at your "+target+"."
+"\n\n"+extraText)
showButton("*gulp*")

if (!audio_estim) playBackgroundSound("stripordie/horror.mp3")
if(!getBoolean("<h1>*** LAST CHANCE ***</h1>Once you click past this screen, the game begins, and you are committed "
+"to either strip naked or suffer a painful punishment."
+"\n\nIf you quit early, you may be caught and exposed, so be careful! "
+"If you take longer than 30 minutes between trigger pulls, I may think you're cheating."
+"\n\nThis is your last chance to chicken out! Are you sure you're ready for this?","Yes","No")) {
    quit = true
    noPlay = true
}

loadGun()

while(!quit) {
    def playedNaked = false
    def tempToggle = true
	def plays = 1

	// Each replay increases the chance of longer exposure
	if (plays < 3) expiration = getRandom(7)+plays
	else expiration = getRandom(7)+3

	// Set extensions
	extensions = (int) (3/bullets)
	extime = getRandom(7-bullets)+1

    // Randomly select a player/pic for cheat monitoring
    cheatNabber(playerBeforePic)

    // Fire
    while (!dead && !playedNaked) {
        if (cheatWatching && !offlineMode) send("stripordie.cheat.time",getTime())

        // Choose new random countdown time
        if (blindCountdown)
        countdown = getRandom(maxSurprise)+minSurprise

        // Remind player of the stakes
        def warnPlayer = ""
        if ((playerWearing == 0) && (useWebcam) && (imageKeyBefore != null) && (imageKeyAfter != null)) {
            def tauntFinal = ["If you survive this round, your body will be exposed for all to see!",
            "This is it! \n\nWhen I pull this trigger, either everyone sees you naked, or you die!",
            "It's all on the line this time! Who's going to see you?",
            "You know I'm going to share your nude pics if you survive this one, right?"]
            warnPlayer = "Your pictures have already been uploaded successfully, but aren't visible...yet!\n\n"+tauntFinal[getRandom(4)]+"\n\n"
        }

        setImage("stripordie/gungirl1.jpg")

        // Spin the cylinder or fire
		playBackgroundSound("stripordie/cock.mp3")
        if(getBoolean("<h1>Fire!</h1>"+warnPlayer + "Are you feeling lucky?","Spin","Pull Trigger")) {
			spin()
        		setImage("stripordie/gungirl1.jpg")
		}
        else {
            def countd = countdown
			if (!audio_estim) {
				playBackgroundSound("guillotine/heart.mp3",10)
			}

            // Start the countdown
            while (countd > 0) {
                if (blindCountdown) {
                    if (tempToggle) {
                        tempToggle = false
                        show("...waiting...")
                    } else {
                        tempToggle = true
                        show("...WAITING...")
                    }
                } else {
                    show("..."+countd+"...")
                }
                wait(1)
                countd = countd - 1
            }
			
		    if (!audio_estim) playBackgroundSound(null)
            fire()

            // Player was stripped naked
            if (strippedNaked) {
			    if (!audio_estim) playBackgroundSound("spinthebottle/gasp.mp3")
                def tauntStripped = ["Haha!\n\nI made you strip naked! I'm loving this...",
                "Well, you're naked now.\n\nAt least you're not in pain...yet!",
                "Awww, I'd a little disappointed!\n\nI was hoping to fry your "+target+"!",
                "Don't be shy!\n\nYou knew from the start you may end up naked.",
                "Well this is awkward!\n\nDid you actually think you'd have to strip naked?",
                "No covering up!\n\nI want to see everything...and so does everyone else! LOL",
                "You seem a bit nervous!\n\nNow that you're naked, are you worried about what's coming next?"]
                show(tauntStripped[getRandom(7)])
                if ((useWebcam) && (!shadowBan)) SendPictures()
                showButton("This is so humiliating!")
                strippedNaked = false
            } else if (playerWearing == 0) playedNaked = true
        }
    }

    show(null)
    setImage("stripordie/gungirl3.jpg")

    // Dead
    if (dead) {
        def tauntDead = ["OMG! Your poor "+target+"!",
        "Are you still trembling? Poor baby!",
        "I can't even imagine how painful that must have been!",
        "Awww, at least you kept your modesty this time!"]
        show("<h1>Shot Dead!</h1>"+tauntDead[getRandom(4)])

        // Record Obituary
        if ((useWebcam) && (!shadowBan) && ((reactCam) || (beforeCam))) SendObit()

        wait(5)
    }

    // Again?
    if(!getBoolean("Want to keep playing?","Yes","No")) quit = true
    else {
        // Get another nude picture each time
        if (!dead && useWebcam && !shadowBan) {
            dispPlayer()
			text = "Picture time! \n\nSince you're already naked, each subsequent picture needs to be "
            text += "more and more embarassing or humiliating. \n\nUp the ante, "+playerName+"!"
			if (publicMode) {
				text += "\n\nIn addition to a more humiliating picture, the time you could be exposed will also be increased!"
			}
            show(text)
            showButton("Ready")
            takePic()
            if (!offlineMode) {
                imageKeyAfter = sendImage(playerAfterPic)
            }
            show(null)
        }

        // Only re-load if player died
        if (dead) {
			if (!audio_estim) playBackgroundSound("stripordie/load.mp3")
            setImage("stripordie/gungirl2.jpg")
            show("Ok, re-loading!")
            wait(3)
            dead = false
            loadGun()
        }
		plays += 1
    }
}

// Active players get different goodbye
if (!noPlay) {
    noCheat()
    catchCheat()
    goodbye()
} else {
    show("Come back when you have the guts to play!\n\nGoodbye!")
}

// This script, from http://ss.deviatenow.com, is protected by this licence :
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/

/*
 * Resources
 * scripts/stripordie.groovy
 * images/stripordie/*
 * images/interrogation/humiliate.jpg
 * sounds/stripordie/*
 * sounds/spinthebottle/gasp.mp3
 * sounds/jackoffrace/gasp-5-with-shock.mp3
 * sounds/spinthebottle/laughing.mp3
 * sounds/guillotine/heart.mp3
*/
